#define TIMEUPDATE 1200
mob
	var
		date/time
		timezone = "PST"
	New()
		..()
		time = new("PST")
		spawn() AddTime()
	proc
		AddTime()
			var/Update = TIMEUPDATE
			while(1)
				time.Add_Time(1)
				Update--
				if(!Update)
					Update = TIMEUPDATE
					time.Update()
				sleep(10)
	Stat()
		statpanel("User")
		stat("Key:",key)
		if(time) stat("Time:",time.ToText())
		stat("Time zone:",timezone)
		return ..()
	verb
		Set_Timezone()
			var
				hour= input("What hour offset of GMT are you one?") as num
				min = input("What minute offset of GMT are you on?")as num
			for(var/Type in typesof(/timezone) - /timezone)
				var/timezone/zone = new Type
				if(zone.hour_offset == hour && zone.minute_offset == min)
					var
						text = "[zone.type]"
						find = findtext(text,"/")
						typename = ""
					while(find)
						typename = copytext(text,find+1)
						find = findtext(text,"/",find+1)
					world << "Timezone set to [typename]. \
This may be incorrect if you are using different summer or daylight \
savings time."
					time = new("[typename]")
					timezone = typename
					world << "According to your input it should be \
about [time.ToText()]"
		Say(Text as text)
			for(var/mob/M in world)
				if(M && M.time)
					M << "\[[M.time.ToText("hh:mm ?M MONTH DD")]] \
[key]: [Text]"